/*
  Copyright 2010-2012 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <QtGui>
#include <QString>

#include "TabDelegate.hpp"

QWidget * TabDelegate::createEditor (QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const
{
    QLineEdit* lineEdit = new QLineEdit(parent);

    if (_completer)
	lineEdit->setCompleter(_completer);

    return lineEdit;
}

void TabDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
				  const QModelIndex &index) const
{
    QLineEdit *line = qobject_cast<QLineEdit *>(editor);
    QString value = line->text().trimmed();

    if ((*_operations)[index.row()].parent)
	model->setData(index, qVariantFromValue("    " + value));
    else
	model->setData(index, qVariantFromValue(value));
}

void TabDelegate::setEditorData(QWidget *editor,
				 const QModelIndex &index) const
{
    QLineEdit* line = qobject_cast<QLineEdit *>(editor);
    QString s = qVariantValue<QString>(index.data());

    line->setText(s.trimmed());
}
